/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


// May contain unused imports in some cases
// @ts-ignore
import type { ApplicationProfileMinimalDto } from './application-profile-minimal-dto';
// May contain unused imports in some cases
// @ts-ignore
import type { DisciplineDto } from './discipline-dto';
// May contain unused imports in some cases
// @ts-ignore
import type { FixedValueForResourceManipulationDto } from './fixed-value-for-resource-manipulation-dto';
// May contain unused imports in some cases
// @ts-ignore
import type { LicenseDto } from './license-dto';
// May contain unused imports in some cases
// @ts-ignore
import type { ProjectMinimalDto } from './project-minimal-dto';
// May contain unused imports in some cases
// @ts-ignore
import type { ResourceTypeDto } from './resource-type-dto';
// May contain unused imports in some cases
// @ts-ignore
import type { UserMinimalDto } from './user-minimal-dto';
// May contain unused imports in some cases
// @ts-ignore
import type { VisibilityDto } from './visibility-dto';

/**
 * Represents a Data Transfer Object (DTO) for resource details.
 * @export
 * @interface ResourceDto
 */
export interface ResourceDto {
    /**
     * Unique identifier for the resource.
     * @type {string}
     * @memberof ResourceDto
     */
    'id'?: string;
    /**
     * Persistent identifier for the resource.
     * @type {string}
     * @memberof ResourceDto
     */
    'pid': string;
    /**
     * 
     * @type {ResourceTypeDto}
     * @memberof ResourceDto
     */
    'type': ResourceTypeDto;
    /**
     * Name of the resource.
     * @type {string}
     * @memberof ResourceDto
     */
    'name': string;
    /**
     * Display name of the resource.
     * @type {string}
     * @memberof ResourceDto
     */
    'displayName': string;
    /**
     * Description of the resource.
     * @type {string}
     * @memberof ResourceDto
     */
    'description': string;
    /**
     * Keywords associated with the resource.
     * @type {Array<string>}
     * @memberof ResourceDto
     */
    'keywords'?: Array<string> | null;
    /**
     * 
     * @type {LicenseDto}
     * @memberof ResourceDto
     */
    'license'?: LicenseDto;
    /**
     * Usage rights associated with the resource.
     * @type {string}
     * @memberof ResourceDto
     */
    'usageRights'?: string | null;
    /**
     * Indicates whether a local copy of the metadata is available for the resource.
     * @type {boolean}
     * @memberof ResourceDto
     */
    'metadataLocalCopy'?: boolean;
    /**
     * Indicates whether metadata extraction is enabled for the resource.
     * @type {boolean}
     * @memberof ResourceDto
     */
    'metadataExtraction'?: boolean;
    /**
     * 
     * @type {ApplicationProfileMinimalDto}
     * @memberof ResourceDto
     */
    'applicationProfile': ApplicationProfileMinimalDto;
    /**
     * Fixed values associated with resource manipulation.  This dictionary may contain multiple levels and is structured as follows:  Dictionary (Key: string) -> Dictionary (Key: string) -> List of FixedValueForResourceManipulationDto.
     * @type {{ [key: string]: { [key: string]: Array<FixedValueForResourceManipulationDto>; }; }}
     * @memberof ResourceDto
     */
    'fixedValues': { [key: string]: { [key: string]: Array<FixedValueForResourceManipulationDto>; }; };
    /**
     * Disciplines associated with the resource.
     * @type {Array<DisciplineDto>}
     * @memberof ResourceDto
     */
    'disciplines': Array<DisciplineDto>;
    /**
     * 
     * @type {VisibilityDto}
     * @memberof ResourceDto
     */
    'visibility': VisibilityDto;
    /**
     * Date when the resource was created.
     * @type {string}
     * @memberof ResourceDto
     */
    'dateCreated'?: string | null;
    /**
     * 
     * @type {UserMinimalDto}
     * @memberof ResourceDto
     */
    'creator'?: UserMinimalDto;
    /**
     * Indicates whether the resource is archived.
     * @type {boolean}
     * @memberof ResourceDto
     */
    'archived'?: boolean;
    /**
     * Indicates whether the resource is in maintenance mode.
     * @type {boolean}
     * @memberof ResourceDto
     */
    'maintenanceMode'?: boolean;
    /**
     * The projects associated with the resource.
     * @type {Array<ProjectMinimalDto>}
     * @memberof ResourceDto
     */
    'projects'?: Array<ProjectMinimalDto> | null;
}

